CASSCO ; #######################################################
 ;	CASSETTE LOAD EVALUATION ROUTINE
 ;	COPYRIGHT (C) 1980 BY
 ;	DENNIS BATHORY KITSZ
 ;	ROXBURY, VERMONT  05669
 ; #######################################################
 ;
 	ORG	7000H		; START IN HIGH MEMORY
 VIDEO	EQU	3C00H		; BEGINNING OF SCREEN
 ;
 ; #######################################################
 ; CLEAR SCREEN SUBROUTINE CALLED BEFORE MESSAGE DISPLAY
 ; #######################################################
 ;
 CLEAR	LD	HL,VIDEO	; CLEAR SCREEN: START
 	LD	DE,VIDEO+1	; DESTINATION OF SPACE
 	LD	BC,3FFH		; NUMBER OF SCREEN POSNS
 	LD	(HL),20H	; IMPLANT SPACE CHARACTER
 	LDIR			; DO IT A SCREENFUL
 	RET			; BACK FROM SUBROUTINE
 ;
 ; #######################################################
 ; DELAY SUBROUTINE CALLED BETWEEN DISPLAY OF INPUT DATA
 ; #######################################################
 ;
 DELAY	PUSH	AF		; DELAY:  SAVE VALUE IN A
 	PUSH	BC		; SAVE VALUE IN BC
 	LD	BC,8000H	; GET DELAY VALUE (1/2 S)
 LOOPN	DEC	BC		; BEGIN DELAY PROCESS
 	LD	A,B		; GET B INTO A FOR TEST
 	OR	C		; COMPARE WITH C FOR ZERO
 	JR	NZ,LOOPN	; KEEP TRYING IF NOT ZERO
 	POP	BC		; RESTORE VALUE TO BC
 	POP	AF		; RESTORE VALUE TO AF
 	LD	A,(3840H)	; TEST OF PRESS OF KEY
 	AND	A		; ENT,CLR,BRK,SPC,ARROWS
 	RET	Z		; BACK IF NONE PRESSED
 	POP	AF		; OTHERWISE CLEAR STACK
 	JR	ENTRY0		; AND BACK TO THE MENU
 	RET			; RETURN FROM SUBROUTINE
 ;
 ; #######################################################
 ; FOLLOWING ROUTINES EACH DISPLAY THEIR RESPECTIVE PROMPT
 ; #######################################################
 ;
 MESSG1	LD	HL,CHART	; DISPLAY MESSAGE #1
 	LD	DE,VIDEO+80H	; PLACE TO DISPLAY IT
 	LD	BC,3FH		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	LD	HL,TESTNG	; DISPLAY TEST MESSAGE
 	LD	DE,VIDEO+280H	; PLACE TO DISPLAY IT
 	LD	BC,80H		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	RET			; BACK FROM SUBROUTINE
 MESSG2	LD	HL,COPYR	; DISPLAY COPYRIGHT MESG.
 	LD	DE,VIDEO+300H	; PLACE TO DISPLAY IT
 	LD	BC,40H		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	RET			; BACK FROM SUBROUTINE
 MESSG3	LD	HL,WANTS	; DISPLAY PROMPT MESSAGE
 	LD	DE,VIDEO+100H	; PLACE TO DISPLAY IT
 	LD	BC,3FH		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	LD	HL,ISI		; INFORMATION MESSAGE
 	LD	DE,VIDEO+180H	; PLACE TO DISPLAY IT
 	LD	BC,3FH		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	LD	HL,QUEST	; PROMPT TO DISPLAY
 	LD	DE,VIDEO+200H	; PLACE TO DISPLAY IT
 	LD	BC,3FH		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	RET			; BACK FROM SUBROUTINE
 MESSG4	LD	HL,MAKING	; MESSAGE TO DISPLAY
 	LD	DE,VIDEO+280H	; PLACE TO DISPLAY IT
 	LD	BC,80H		; NUMBER OF BYTES TO SHOW
 	LDIR			; DISPLAY THE MESSAGE
 	RET			; BACK FROM SUBROUTINE
 ;
 ; #######################################################
 ; CLEAR SCREEN, DISPLAY MENU & PROMPT, GET USER ENTRY
 ; #######################################################
 ;
 ENTRY0	CALL	CLEAR		; RESTART OF PROGRAM
 	CALL	MESSG3		; DISPLAY MESSAGE #3
 	CALL	MESSG2		; DISPLAY MESSAGE #2
 KEYTST	LD	A,(3810H)	; LOOK AT THE KEYBOARD
 	CP	2		; IS IT A NUMBER "1"?
 	JR	Z,TAPER		; IF SO, GO TO TAPE MAKE
 	CP	4		; IS IT A NUMBER "2"?
 	JR	Z,ENTRY1	; IF SO, GO TO TAPE TEST
 	CP	8		; IS IT A NUMBER "3"?
 	JR	NZ,KEYTST	; IF NOT, GO TO KEY TEST
 	CALL	CLEAR		; CLEAR THE SCREEN
 	JP	06CCH		; BACK TO BASIC "READY"
 ;
 ; #######################################################
 ; PREPARE A TEST TAPE CONSISTING SOLELY OF BIN. 1111 1111
 ; #######################################################
 ;
 TAPER	CALL	MESSG4		; DISPLAY MESSAGE #4
 REPAT	LD	A,0FFH		; GET 11111111 TO WRITE
 	CALL	0264H		; WRITE THAT BYTE
 	LD	A,(3840H)	; LOOK AT THE KEYBOARD
 	AND	A		; IS ENT,CLR,BRK,SPC ?
 	JR	Z,REPAT		; IF NOT, THEN NEXT BYTE
 	JR	ENTRY0		; IF SO THEN BACK TO MENU
 ;
 ; #######################################################
 ; TWO-PART DISPLAY ROUTINE - TOP AND BOTTOM LINE OF A
 ; PSEUDO DIGITAL STORAGE SCOPE LOOKS LIKE A SQUARE WAVE
 ; #######################################################
 ;
 ENTRY1	CALL	CLEAR		; CLEAR THE SCREEN
 	CALL	MESSG1		; DISPLAY MESSAGE #1
 	CALL	MESSG2		; DISPLAY MESSAGE #2
 LOOPX	LD	HL,VIDEO+100H	; GET 4 LINES DOWN SCREEN
 	LD	DE,VIDEO+200H	; GET 8 LINES DOWN SCREEN
 LOOP2	XOR	A		; CLEAR ACCUMULATOR TO 0
 	OUT	(0FFH),A	; RESET INSIG FLIP-FLOP
 	LD	A,8FH		; GET GRAPHICS CHARACTER
 	LD	(HL),A		; DISPLAY IT ON SCREEN
 	LD	A,20H		; GET SPACE CHARACTER
 	LD	(DE),A		; DISPLAY IT ON SCREEN
 	INC	L		; GET NEXT SCREEN POS'N
 	INC	E		; GET NEXT SCREEN POS'N
 	IN	A,(0FFH)	; GET VALUE AT CASSETTE
 	BIT	7,A		; TEST CONDITION OF DATA
 	PUSH	AF		; SAVE THE VALUE A MOMENT
 	LD	A,L		; GET L SCREEN POSITION
 	CP	40H		; IS IT AT END OF LINE?
 	JR	Z,OUT1		; IF SO, THEN RESET IT
 	POP	AF		; RESTORE VALUE TO AF
 	JR	NZ,LOOP2	; AND GO BACK TO CONTINUE
 	JR	Z,LOOP3		; OTHERWISE GO TO RESET
 OUT1	LD	L,0		; RESET HL TO 3D00H
 	LD	E,0		; RESET DE TO 3E00H
 	CALL	DELAY		; DELAY A BEFORE NEXT
 	POP	AF		; CLEAR THE STACK
 	JR	NZ,LOOP2	; FORMER FLAG TEST
 LOOP3	XOR	A		; ELSE CLEAR ACCUMULATOR
 	OUT	(0FFH),A	; RESET INSIG FLIP-FLOP
 	LD	A,8FH		; GET GRAPHICS CHARACTER
 	LD	(DE),A		; PLACE IT ON THE SCREEN
 	LD	A,20H		; GET A SPACE
 	LD	(HL),A		; DISPLAY IT ON SCREEN
 	INC	L		; GET NEXT TOP LINE POSN
 	INC	E		; GET NEXT BOTTOM LINE
 	IN	A,(0FFH)	; GET VALUE FROM CASSETTE
 	BIT	7,A		; TEST THE DATA BIT
 	PUSH	AF		; SAVE THE VALUE & FLAGS
 	LD	A,E		; GET VALUE AT SCREEN
 	CP	40H		; IS IT AT END OF LINE?
 	JR	Z,OUT2		; IF SO THEN RESET SCREEN
 	POP	AF		; RESTORE VALUE & FLAGS
 	JR	Z,LOOP3		; IF ZERO THEN RELOOP
 	JR	NZ,LOOP2	; IF NOT ZERO THEN OTHER
 OUT2	LD	L,0		; RESET TOP LINE TO 00
 	LD	E,0		; RESET BOTTOM LINE TO 00
 	CALL	DELAY		; DELAY FOR A WHILE
 	POP	AF		; RESTORE FORMER VALUE
 	JR	Z,LOOP3		; IF ZERO THEN BACK 
 	JR	ENTRY1		; ELSE BACK TO THE MENU
 ;
 ; #######################################################
 ; DISPLAY MESSAGES, INCLUDING PROMPTS AND SCOPE CHART
 ; #######################################################
 ;
 CHART	DEFM	'00 01 02 03 04 05 06 07 08 09 10 '
 	DEFM	'11 12 13 14 15 16 17 18 19 20   '
 COPYR	DEFM	'COPYRIGHT (C) 1980 BY DENNIS '
 	DEFM	'BATHORY KITSZ. ALL RIGHTS RESERVED. '
 WANTS	DEFM	'                     ** CASSETTE-SCOPE '
 	DEFM	'**                             '
 ISI	DEFM	'A "STORAGE SCOPE" PICTURE OF THE CA'
 	DEFM	'SSETTE INPUT WAVEFORM AT PORT 255'
 QUEST	DEFM	'<1> TO MAKE TAPE, <2> TO TEST TAPE, '
 	DEFM	'<3> TO RETURN TO BASIC       '
 MAKING	DEFM	'LOAD TAPE INTO RECORDER.  SET MACHINE '
 	DEFM	'TO RECORD, AND TURN IT ON '
 	DEFM	'MANUALLY.  RECORDING IS CONTINUOUS. '
 	DEFM	'PRESS <BREAK> TO RETURN MENU.       '
 TESTNG	DEFM	'LOAD TAPE INTO RECORDER.  SET MACHINE '
 	DEFM	'TO PLAY, AND TURN IT ON '
 	DEFM	'  MANUALLY.   HOLD <BREAK> DOWN FOR ONE'
 	DEFM	' SECOND TO RETURN MENU.         '
 	END	ENTRY0
